apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: npm-registry
spec:
  serviceName: npm-registry
  selector:
    matchLabels:
      app: npm-registry
  replicas: 2
  template:
    metadata:
      labels:
        app: npm-registry
    spec:
      containers:
        - name: verdaccio
          image: docker.io/verdaccio/verdaccio:6.0.5@sha256:58353ed1b53ebb3e6fc2925a5384f70a4aa3ddac7a1402d717a39951e7ab43ad
          ports:
            - name: verdaccio
              containerPort: 4873
          livenessProbe:
            tcpSocket:
              port: 4873
          readinessProbe:
            httpGet:
              path: /
              port: 4873
          lifecycle:
            preStop:
              exec:
                command:
                  - sh
                  - -c
                  - sleep 10
          volumeMounts:
            - mountPath: /verdaccio/storage
              name: storage
            - mountPath: /verdaccio/conf
              name: config
          resources:
            requests:
              memory: 1000Mi
              cpu: 10m
            limits:
              memory: 1000Mi
              cpu: 1100m
      securityContext:
        fsGroup: 1000
      volumes:
        - name: config
          configMap:
            name: npm-registry
  volumeClaimTemplates:
    - metadata:
        name: storage
      spec:
        accessModes:
          - ReadWriteOnce
        resources:
          requests:
            storage: 40Gi
